## PSAM卡与APDU指令

### 文档说明
- APDU指令

    固定四个字节命令头（CLA INS P1 P2）和长度可变的命令体(Lc 数据域 Le)

    CLA字节指出命令的类型

    INS字节表示命令编码，P1和P2为具体命令参数

    Lc字节表示数据的长度，只有一个字节表示，取值范围为1-110.如果Lc为0表示没有数据域。

    Le表示期望卡返回的数据长度，由单字节表示，取值范围1-254字节


    一、 Write Key增加和修改密钥

    1）命令报文

    明文安装或修改密钥报文如下：

    | 代码 |值|
    |---|---|
    | CLA |80|
    |INS|D4|
    |P1| 00 -安装密钥<br/> 01-修改密钥|
    |P2|00|
    |Lc|密钥信息长度|
    |DATA|密钥信息|

    密文安装或修改密钥命令报文如下：

    | 代码 |值|
    |---|---|
    | CLA |80|
    |INS|D4|
    |P1| 00 -用于安装密钥<br/> XX-密钥类型(用于修改密钥)|
    |P2|00--用于安装密钥<br/> XX-密钥标识、版本(用于修改密钥)|
    |Lc|密钥信息长度|
    |DATA|加密后的密钥信息+4字节MAC码|

    [注1] 当密钥类型和标识都为00时，如果密钥文件为空,则表示安装卡片（或者应用）主控密钥，
    如果安装卡片（或应用）主控密钥已经存在，则表示修改卡片（或者应用的）主控密钥。

     2）命令报文数据域

    - 明文形式的数据域信息

    - 明文+MAC形式的数据域信息

    - 密文形式的数据域信息


- APDU响应

    响应应用数据单元包括两部分：可能存在的响应数据体（应答体）和两个状态字节（应答尾部）

- PSAM说明
- 通讯协议

    ISO7816-3中定义的异步半双工字符传输协议（T=0）



### 项目结构


### 计划功能


### 如何扩展


### 注意事项